Subject: Re: [PATCH v2 bpf-next 01/10] ice: allow toggling loopback mode via ndo_set_features callback

From: Maciej Fijalkowski <[email-masked]>
Date: Thu, 16 Jun 2022 19:00:11 +0200

On Thu, Jun 16, 2022 at 09:47:40AM -0700, Jakub Kicinski wrote:
> On Thu, 16 Jun 2022 18:00:40 +0200 Maciej Fijalkowski wrote:
> > > Loopback or not, I don't think we should be accepting the shutdown ->
> > > set config -> pray approach in modern drivers. ice_open() seems to be
> > > allocating all the Rx memory, and can fail.  
> > 
> > They say that those who sing pray twice, so why don't we sing? :)
> > 
> > But seriously, I'll degrade this to ice_down/up and check retvals. I think
> > I just mimicked flow from ice_self_test(), which should be fixed as
> > well...
> > 
> > I'll send v4.
> 
> checking retval is not enough, does ice not have the ability to
> allocate resources upfront? I think iavf was already restructured
> to follow the "resilient" paradigm, time for ice to follow suit?

I'm not aware of such restructure TBH. FWIW ice_down() won't free
irqs/rings. I said I'll switch to it plus check its retval whereas I feel
like you took it like I would want to keep the ice_stop() and check its
retval.

> 
> This is something DaveM complained about in the first Ethernet driver 
> I upstreamed, which must have been a decade ago by now. It's time we
> all get on board :)